## org.apache.mahout.cf.taste.impl.recommender.svd
Class AbstractFactorizer

    java.lang.Object
      org.apache.mahout.cf.taste.impl.recommender.svd.AbstractFactorizer

All Implemented Interfaces:
  Refreshable, Factorizer

Direct Known Subclasses:
  ALSWRFactorizer, ParallelSGDFactorizer, RatingSGDFactorizer

    public abstract class AbstractFactorizer

extends Object
implements Factorizer

base class for `Factorizer`s, provides ID to index mapping

Constructor Summary
`protected` `AbstractFactorizer(DataModel dataModel)`

Method Summary
`protected Factorization` `createFactorization(double[][] userFeatures, double[][] itemFeatures)`
`protected Integer` `itemIndex(long itemID)`
`void` `refresh(Collection<Refreshable> alreadyRefreshed)` Triggers "refresh" -- whatever that means -- of the implementation.
`protected Integer` `userIndex(long userID)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.mahout.cf.taste.impl.recommender.svd.Factorizer
`factorize`

Constructor Detail

### AbstractFactorizer

    protected AbstractFactorizer(DataModel dataModel)
                          throws TasteException

Throws:
  `TasteException`

Method Detail

### createFactorization

    protected Factorization createFactorization(double[][] userFeatures,
                                                double[][] itemFeatures)

### userIndex

    protected Integer userIndex(long userID)

### itemIndex

    protected Integer itemIndex(long itemID)

### refresh

    public void refresh(Collection<Refreshable> alreadyRefreshed)

  Description copied from interface: `Refreshable`

  Triggers "refresh" -- whatever that means -- of the implementation. The general contract is that any `Refreshable` should always leave itself in a consistent, operational state, and that the refresh atomically updates internal state from old to new.

  Specified by:
    `refresh` in interface `Refreshable`
  Parameters:
    `alreadyRefreshed` - `Refreshable`s that are known to have already been refreshed as a result of an initial call to a `Refreshable.refresh(Collection)` method on some object. This ensure that objects in a refresh dependency graph aren't refreshed twice needlessly.

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.